	org 25000

  ; loading bar
  ld hl,0x5995
  ld b,10
loading_bar_lp
  ld (hl),0x20
  inc l
  halt
  djnz loading_bar_lp

  ; copy intro data to page 7
  ld bc,0x7ffd
  ld a,0x17
  out (c),a
  ld (0xfffd),a ; mark page 7
  ld hl,intro_data
  ld de,0xc000
  ld bc,intro_len
  ldir

  ; copy mainpart data to page 0
  ld bc,0x7ffd
  ld a,0x10
  out (c),a
  ld (0xfffd),a ; mark page 0
  ld hl,main_data
  ld de,0xc000
  ld bc,main_len+screen_len
  ldir

  ; attempt to switch back to page 7
  ld bc,0x7ffd
  ld a,0x17
  out (c),a
  ; test that we really are on page 7
  ld hl,0xfffd
  cp (hl)
  jr nz,is_48k  ; no? this is a 48k machine then, so skip to main part
  
  ; copy intro data back to 26000 for playing
  ld hl,0xc000
  ld de,26000
  ld bc,intro_len
  ldir
  call 26000
  
  ; switch back to page 0
  ld bc,0x7ffd
  ld a,0x10
  out (c),a
is_48k
  ; depack screen
  ld hl,0xc000+main_len ; = relocated screen_data
  ld de,0x4000
  call dehrust
  ; relocate main_data to 26000 for depacking
  ld hl,0xc000
  ld de,26000
  ld bc,main_len
  ldir
  ld hl,26000
  ld d,h
  ld e,l
  call dehrust
  jp 0x8000

	include dehrust.asm

intro_data  incbin intro.bin
intro_len   equ $ - intro_data
main_data   incbin tfvr.bin.hr
main_len    equ $ - main_data
screen_data incbin conductor.scr.hr
screen_len  equ $ - screen_data