  org 26000
  
  ; set up interrupt routine to test timings
  ld hl,0xbe00
  ld de,0xbe01
  ld (hl),0xbdbd
  ld bc,0x0100
  ldir
  
  ld a,0xc3 ; JP
  ld (0xbdbd),a
  ld hl,int_routine
  ld (0xbdbe),hl
  
  ld a,0xbe
  di
  ld i,a
  im 2
  ei
  halt
  ld a,0xfd ; jump -3, to jump back to inc bc instruction
  ld (loop_ptr+1),a
  
  ld bc,0
  inc bc
loop_ptr
  jr $
  
  ; remove interrupt routine
  di
  im 1
  ei
  
  ; bc = 3183 for zx128
  ; bc = 3978 for pentagon
  ; bc = 3878 for scorpion
  
  ; add 128 to get distinct high bytes: zx128 = 0x0c, scorpion = 0x0f, pentagon = 0x10

  ld hl,0x0080
  add hl,bc

; take this opportunity to page in page 7
  ld bc,0x7ffd
  ld a,0x17
  out (c),a

  ld a,h
  
  cp 0x10
  jr z,depack_for_pentagon
  cp 0x0f
  jr z,depack_for_scorpion

depack_for_zx128
  ld hl,intro_core_hr
  ld de,0x8000
  call dehrust
  ld hl,border_zx128_hr
  ld de,0x9000
  call dehrust
  ld hl,paint_frame_others_hr
  ld de,0x9100
  call dehrust
  jp 0x8000

depack_for_pentagon
  ld hl,intro_core_hr
  ld de,0x8000
  call dehrust
  ld hl,border_pentagon_hr
  ld de,0x9000
  call dehrust
  ld hl,paint_frame_pentagon_hr
  ld de,0x9100
  call dehrust
  jp 0x8000

depack_for_scorpion
  ld hl,intro_core_hr
  ld de,0x8000
  call dehrust
  ld hl,border_scorpion_hr
  ld de,0x9000
  call dehrust
  ld hl,paint_frame_others_hr
  ld de,0x9100
  call dehrust
  jp 0x8000

int_routine
  ; removes jr offset and returns
  xor a
  ld (loop_ptr+1),a
  ei
  ret
  
  include dehrust.asm
border_zx128_hr
  incbin border_zx128.bin.hr
border_pentagon_hr
  incbin border_pentagon.bin.hr
border_scorpion_hr
  incbin border_scorpion.bin.hr
paint_frame_pentagon_hr
  incbin paint_frame_pentagon.bin.hr
paint_frame_others_hr
  incbin paint_frame_others.bin.hr
intro_core_hr
; put this last so that if it overflows 0x8000, it depacks on top of itself non-destructively
  incbin intro_core.bin.hr
