  org 25000

  ; loading bar
  ld hl,0x5980
  ld b,10
loading_bar_lp
  ld (hl),0x20
  inc l
  halt
  djnz loading_bar_lp

  ; perform reset of the GS and look for the tell-tale response
  ld a,0xf4
  out (0xbb),a
  ld b,100
cold_start_lp
  halt
  djnz cold_start_lp
  in a,(0xb3)
  inc a
  ret z ; if result is 255, clearly no GS there

  ; set 0xfffe to 42 to indicate successful detection
  ld a,42
  ld (0xfffe),a

  ld hl,packdata
  ld d,h
  ld e,l
  call dehrust
	
	; load GS with MOD data
  ld a,0x30
  out (0xbb),a		; Command 30 = Load Module in memory
ack1: in a,(0xbb) ; wait for acknowledgement
  rrca
  jr c,ack1
  in a,(0xb3)     ; fetch module number from output register
  ld (0xffff),a	; remember result
  ld a,0xd1       ; Command D1 = Open stream
  out (0xbb),a
ack2: in a,(0xbb) ; wait for acknowledgement
  rrca
  jr c,ack2

  ld hl,packdata	; start address
  ld bc,mod_data_length	; length

gs_data_lp:
  ld a,(hl)
  out (0xb3),a		; output byte to GS
ack3: in a,(0xbb) ; wait for acknowledgement
  rlca
  jr c,ack3
  inc hl		; next address
  dec bc
  ld a,b
  or c			; loop until bc=0
  jp nz,gs_data_lp
  ret

	include dehrust.asm

packdata	incbin mod_data_1.bin.hr
