; macro to align on an 'n' byte boundary
align  macro n
       org ($ + n - 1) / n * n
       endm

;multicolour.bin
	org	0x8000

	ld bc,0x7ffd
	ld a,0x17
	out (c),a
	; fill both screens with 00001111
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x17ff
	ld (hl),0x0f
	ldir
	ld hl,0xc000
	ld de,0xc001
	ld bc,0x17ff
	ld (hl),0x0f
	ldir
	call stc_init_entry
	di	
	ld a,0xbd
	ld i,a
	im 2
	ei	
mainloop:
	halt	
	call stc_play
	call fiddle_volume
	call stc_out_ay
	
	; handle fade-out-at-end
framecount
  ld hl,9280
  ld a,h
  or l
  jr nz,notfaded
  
endfade_cyc
  ld a,40
  dec a
  jp nz,endfade_nodown
  ld a,(curr_volume+1)
  dec a
  jr z,shutdown
  ld (curr_volume+1),a

  ld a,40
endfade_nodown:
  ld (endfade_cyc+1),a
  jp endfade_done

notfaded:
  dec hl
  ld (framecount+1),hl
endfade_done:
	
	ld bc,0x7ffe	; wait for key
	in a,(c)
	and 0x01
	jr nz,mainloop
	; fade out music
fadelp
	ld b,4
fadeframes
	push bc
	halt	
	call stc_play
	call fiddle_volume
	call stc_out_ay
	pop bc
	djnz fadeframes
	ld a,(curr_volume+1)
	dec a
	ld (curr_volume+1),a
	jr nz,fadelp

shutdown:
	call stc_init_entry  ; mute
	
	di	
	ld bc,0x7ffd
	ld a,0x17
	out (c),a
	ld hl,0x5800	; blank attributes
	ld de,0x5801
	ld bc,0x02ff
	ld (hl),l	
	ldir
	ld a,0x3f
	ld i,a
	im 1
	ei	
	ret	

fiddle_volume:
  ; point e register at the relevant sub-table for current volume level
curr_volume
  ld a,15
  cp 15
  ret z
  add a,a
  add a,a
  add a,a
  add a,a
  ld e,a
  ld h,vol_table/256

  ld a,(vol_a)
  and 15
  or e
  ld l,a
  ld a,(hl)
  ld (vol_a),a

  ld a,(vol_b)
  and 15
  or e
  ld l,a
  ld a,(hl)
  ld (vol_b),a

  ld a,(vol_c)
  and 15
  or e
  ld l,a
  ld a,(hl)
  ld (vol_c),a
  ret
set_vol_15:
  ld a,15
  ret

  org 0x8100
bordersine
  include "bordersine.asm"
  rept 128
    db 32
  endm

  org 0x8200
border_vals
  defs 33
  org 0x8221
border_palette
  db 1,4,1,4,4,5,4,5,5,7,5,7
  db 2,3,2,3,3,6,3,6,6,7,6,7

  org 0x8280
attrdata:
	incbin "yerz2.attr"
	
border_entry  equ 0x9000
paint_frame_entry equ 0x9100


; volume table
org 0xbb00
vol_table:
  db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
  db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
  db 0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x02
  db 0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x03,0x03,0x03,0x03
  db 0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x02,0x02,0x02,0x03,0x03,0x03,0x04,0x04,0x04
  db 0x00,0x00,0x00,0x01,0x01,0x01,0x02,0x02,0x03,0x03,0x03,0x04,0x04,0x04,0x05,0x05
  db 0x00,0x00,0x00,0x01,0x01,0x02,0x02,0x03,0x03,0x03,0x04,0x04,0x05,0x05,0x06,0x06
  db 0x00,0x00,0x01,0x01,0x02,0x02,0x03,0x03,0x04,0x04,0x05,0x05,0x06,0x06,0x07,0x07
  db 0x00,0x00,0x01,0x01,0x02,0x02,0x03,0x03,0x04,0x05,0x05,0x06,0x06,0x07,0x07,0x08
  db 0x00,0x00,0x01,0x01,0x02,0x03,0x03,0x04,0x05,0x05,0x06,0x06,0x07,0x08,0x08,0x09
  db 0x00,0x00,0x01,0x02,0x02,0x03,0x04,0x04,0x05,0x06,0x06,0x07,0x08,0x08,0x09,0x0a
  db 0x00,0x00,0x01,0x02,0x03,0x03,0x04,0x05,0x06,0x06,0x07,0x08,0x09,0x09,0x0a,0x0b
  db 0x00,0x00,0x01,0x02,0x03,0x04,0x04,0x05,0x06,0x07,0x08,0x08,0x09,0x0a,0x0b,0x0c
  db 0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d
  db 0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e
  db 0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f

	
org 0xbcbc
	push af
	push bc
	push de
	push hl
	exx
	ex af,af'
	push af
	push bc
	push de
	push hl
	push ix
	call border_entry
	call paint_frame_entry
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	ex af,af'
	exx
	pop hl
	pop de
	pop bc
	pop af
	ei
	ret
org 0xbd00
	rept 257
	db 0xbc
	endm
	
	
org 0xdb00
	
	include "stc_player.asm"
	incbin "follsp.stc"

