#!/usr/local/bin/ruby -w
# generate lookup tables for polar coordinates

mask = []
File.open(ARGV[0]) do |f|
  until f.eof? do
    mask << f.getc
  end
end

max_r = Math.sqrt(11.5*11.5 + 15.5*15.5)

-11.5.step(11.5,1) do |y|
  row = []
  -15.5.step(15.5,1) do |x|
    #r = Math.sqrt(y*y + x*x) * 255.5 / max_r
    r = Math.sqrt(y*y + x*x) / max_r
    r = r*r*r * 255.5
    th = (Math::PI + Math.atan2(x,y)) * 255.5 / (2 * Math::PI)
    
    mask_byte = mask.shift
    if mask_byte.nil? or mask_byte == 0x08 # designated 'transparent' colour
      row << (r+th).to_i/4
    else
      row << 0
    end
#    row << th.to_i
  end
  puts "\tdb #{row.join ','}"
end
