  org 26000
font
  include "wider_font.asm"

text
  incbin "scroller.txt"
; defm "~4Trackers forever!~5Trackers forever!~6Trackers forever!~7Trackers forever!"
  db 0

  org 0x8000

; macro to align on an 'n' byte boundary
align  macro n
       org ($ + n - 1) / n * n
       endm

  di
  ld a,0xf6
  ld i,a
  im 2
  ei

;  ld hl,0x4000
;  ld de,0x4001
;  ld bc,0x1800
;  ld (hl),0x44; l
;  ldir
;  ld bc,0x02ff
;  ld (hl),0x47
;  ldir

  ld hl,scroller_buf
  ld de,scroller_buf+1
  ld bc,0x05f0	; clear buffer, but leave last few bytes which
                ; store General Sound status
  ld (hl),l
  ldir

; is GS available?
  ld a,(0xfffe) ; check our flag
  cp 42
  jr nz,mainloop
  ld a,(0xffff) ; retrieve mod handle
  out (0xb3),a
  ld a,0x31     ; GS command : play module
  out (0xbb),a

mainloop
  
  call attribfx
  
  jp mainloop
  
attribfx
  ld hl,background_table
  ld de,0x5800
  ld b,17
  
attr_anim_pos
  ld c,0
  
attribfx_lp1
  rept 31
    proc
    local skipattr
    ld a,(hl)
    or a
    jp z,skipattr
    add a,c
    and 0x38  ; keep ink black
    ld (de),a
skipattr
    inc l
    inc e
    endp
  endm
    proc
    local skipattr
    ld a,(hl)
    or a
    jp z,skipattr
    add a,c
    and 0x38  ; keep ink black
    ld (de),a
skipattr
    inc hl
    inc de
    endp
  dec b
  jp nz,attribfx_lp1
  
  ld b,7
attribfx_lp2
  ld ix,scroller_attrib_buf
  rept 32,col
    ld a,(hl)
    add a,c
    and 0x18
    or (ix+col)
    ld (de),a
    inc l
    inc e
  endm
  dec b
  jp nz,attribfx_lp2

  ld a,(attr_anim_pos+1)
  add a,0xfe
  ld (attr_anim_pos+1),a
  
  ret
  
scroller
textpix
  ld a,1
  dec a
  jp nz,text_nonewchar

textpos  
  ld hl,text
  ld a,(hl)
  or a
  jp nz,text_nowrap
  ld hl,text
  ld a,(hl)
text_nowrap
  cp '~'
  jp nz,text_nochgcol
  inc hl
  ld a,(hl)
  sub '0'
  ; and 0x07  ; translate ascii number to colour
  ld (scroll_colour+1),a
  ld a,' '  ; force a space after the colour code, to avoid colour clash

text_nochgcol
  inc hl
  ld (textpos+1),hl
  
  ; translate to char bitmap
  ld l,a
  ld h,0
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  ld de,font-0x0200
  add hl,de
  ld de,scroller_buf+32

  rept 8
  ldi
  ldi
  dec e
  dec e
  inc d
  endm
  
  ld a,5
text_nonewchar
  ld (textpix+1),a
  
  ld hl,scroller_buf + 33
  ld b,6
scroll
  push hl
  xor a
  rept 33
    rld
    dec hl
  endm
  rld
  pop hl
  inc h
  djnz scroll
  ret
  

; plot sinewave
plotsine
thicksinepos
  ld hl,thickness_sine
  exx
  
topsinepos
  ld hl,sine16
  
  ld bc,scroller_buf
topsinelp
  push bc
    push hl
      exx
        ld e,(hl)
        ld a,l
        add a,14
        ld l,a
        ld bc,0 ; c = used as counter, b = always 0
      exx
      ld l,(hl)
      ld h,ytable/256
    
      ; clear a line
      rept 3
        ld a,(hl)
        or c
        ld e,a
        inc l
        ld d,(hl)
        inc l
        xor a
        ld (de),a
      endm

      rept 12
        ld a,(hl)
        or c
        ld e,a
        inc l
        ld d,(hl)
        inc l

        ld a,(bc)
        ld (de),a

        exx
        ld a,c
        add a,e
        ld c,a
        ld a,b
        exx
        adc a,b
        jp z,plot_char_bailout  ; optimise: jr when we're close enough
        ld b,a

      endm
  
plot_char_bailout
      ; clear the next couple of lines
      rept 5
        ld a,(hl)
        or c
        ld e,a
        inc l
        ld d,(hl)
        inc l
        xor a
        ld (de),a
      endm

    pop hl
    inc l
    inc l
    inc l
  
  pop bc
  inc c
  ld a,c  
  cp 32
  jp nz,topsinelp

  ld a,(topsinepos+1)
  add a,7
  ld (topsinepos+1),a

  ld a,(thicksinepos+1)
  add a,19
  ld (thicksinepos+1),a

  ret

;upde
;  inc d
;  ld a,d
;  and 7
;  ret nz
;  ld a,e
;  add a,32
;  ld e,a
;  ret c
;  ld a,d
;  sub 8
;  ld d,a
;  ret

scroller_attribs
scroll_attrs_tick
  ld a,1
  dec a
  jp nz,no_scroll_attrs
  
  ld de,scroller_attrib_buf
  ld hl,scroller_attrib_buf+1
  rept 31
    ldi
  endm
scroll_colour
  ld a,0x07
  ld (de),a
    
  ld a,2
no_scroll_attrs
  ld (scroll_attrs_tick+1),a
  ret

bg_transition
; every 768 frames, spend 96 frames changing to a new background (8 bytes per frame)
transition_count
  ld bc,768
  dec bc
  ld (transition_count+1),bc
  ld a,b
  or a
  ret nz
  ld a,c
  cp 96
  ret nc
  
  ld h,0    ; translate counter into an offset into shuffled_numbers
  ld l,a
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  ld de,shuffled_numbers
  add hl,de
  ; now grab 8 numbers
  ld a,8
grab_bg_lp
  ld e,(hl)
  inc hl
  ld d,(hl)
  inc hl
  push hl
    ld hl,background_table
    add hl,de
    push hl
current_background
    ld hl,background2
    add hl,de
    pop de
    ldi
  pop hl
  dec a
  jp nz,grab_bg_lp
; handle bc reaching zero
  ld a,(transition_count+1)  ; only need to check low byte
  or a
  ret nz
  ld bc,768
  ld (transition_count+1),bc
  ld hl,(current_background+1)
  ld de,768
  add hl,de
  ld (current_background+1),hl
  ld de,backgrounds_end
  sbc hl,de
  ret c
  ld hl,background1
  ld (current_background+1),hl
  ret
  
  align 0x0100
ytable
; lookup table to translate y coords into screen addresses; bottom third only
  db 0x00,0x50,0x00,0x51,0x00,0x52,0x00,0x53,0x00,0x54,0x00,0x55,0x00,0x56,0x00,0x57
  db 0x20,0x50,0x20,0x51,0x20,0x52,0x20,0x53,0x20,0x54,0x20,0x55,0x20,0x56,0x20,0x57
  db 0x40,0x50,0x40,0x51,0x40,0x52,0x40,0x53,0x40,0x54,0x40,0x55,0x40,0x56,0x40,0x57
  db 0x60,0x50,0x60,0x51,0x60,0x52,0x60,0x53,0x60,0x54,0x60,0x55,0x60,0x56,0x60,0x57
  db 0x80,0x50,0x80,0x51,0x80,0x52,0x80,0x53,0x80,0x54,0x80,0x55,0x80,0x56,0x80,0x57
  db 0xa0,0x50,0xa0,0x51,0xa0,0x52,0xa0,0x53,0xa0,0x54,0xa0,0x55,0xa0,0x56,0xa0,0x57
  db 0xc0,0x50,0xc0,0x51,0xc0,0x52,0xc0,0x53,0xc0,0x54,0xc0,0x55,0xc0,0x56,0xc0,0x57
  db 0xe0,0x50,0xe0,0x51,0xe0,0x52,0xe0,0x53,0xe0,0x54,0xe0,0x55,0xe0,0x56,0xe0,0x57

  align 0x100
sine16
  include "sine_16_148.asm"
  
thickness_sine
  include "sine_63_192.asm"

;attr_mask
;  incbin "clouds.attr"

  
  align 0x100
background_table
  include "background1.asm"

background1
  include "background1.asm"
background2
  include "background2.asm"
background3
  include "background3.asm"
background4
  include "background4.asm"
backgrounds_end
shuffled_numbers
  include "shuffled_numbers.asm"
    
  org 0xf600
  rept 257
    db 0xf7
  endm
  
interrupt
  push af
  push bc
  push de
  push hl
  exx
  push bc
  push de
  push hl
  
;  ld a,3
;  out (254),a
  call plotsine
;  ld a,2
;  out (254),a
  call scroller
;  ld a,4
;  out (254),a
  call scroller_attribs
  call bg_transition
  ld a,0
  out (254),a  
  
  pop hl
  pop de
  pop bc
  exx
  pop hl
  pop de
  pop bc
  pop af
  ei
  ret
  
  org 0xf7f7
    jp interrupt
  
scroller_buf  equ 0xfa00  ; 0x0600 bytes, ending at top of mem; when scaling, bail out when it reaches zero

scroller_attrib_buf  equ 0xfa40  ; 32 suitably unused bytes